<template>
  <div class="BooksTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: open with opw book reader'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      :creatable="false"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="books"
      single-item="book">
      <template slot="controls" slot-scope="prop">
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename book"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete book"></i>
      </template>
    </tab-simple>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/books/get`)
        this.items = data
        console.log('************* books')
        console.log(this.items)
      }
    },
    leftClick(item) {
      const router = this.$router || $nuxt.$router
      router.push({
        path: '/book',
        query: {
          path: path.join(sourcesDir, 'books', `${item.name}`)
        }
      })
    },
    rightClick(item) {

    },
    middleClick(item) {

    },
    createItem() {

    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" book to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid book name'
      }).then(async (data) => {
        const newBookName = data.value
        if (newBookName && newBookName !== item.name) {
          await this.$axios.post(`/books/rename/${item.name}`, {
            newName: data.value
          })
          const index = _.findIndex(this.items, { name: item.name })
          this.items.splice(index, 1, { ...item, name: newBookName })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete book ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/books/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./BooksTab.less";
</style>